<template>
  <div class="search">
    <div class="search__wrapper">
      <input
        class="search__input border-1"
        type="text"
        maxlength="10"
        placeholder="Search"
        v-model="request"
        @input="typeText"
      />

      <button
        v-if="request"
        class="search__clear"
        v-on:click="clearSearch"
      ></button>
    </div>
  </div>
</template>

<script>
export default {
  name: "SearchPanel",
  emits: ["onClear, onType"],
  data: () => {
    return {
      request: "",
    };
  },
  methods: {
    typeText() {
      this.$emit("onType", this.request);
    },
    clearSearch() {
      this.request = "";
      this.$emit("onClear");
    },
  },
};
</script>

<style scoped lang="scss">
.search {
  padding: 50px 0 100px 0;

  @media only screen and (max-width: "550px") {
    padding: 50px 0;
  }

  &__wrapper {
    width: 300px;
    height: 100%;
    position: relative;
    margin: 0 auto;
  }

  &__input {
    height: 40px;
    border-radius: 5px;
    background: rgb(255 255 255 / 33%);
    padding: 0 20px;
    width: 100%;
    font-size: 20px;
  }

  &__clear {
    width: 20px;
    height: 20px;
    position: absolute;
    right: 10px;
    top: 10px;
    cursor: pointer;
    border: 0;
    z-index: 1;
    background: transparent;

    &:hover {
      &::before,
      &::after {
        background-color: #464444;
        transition: background-color 300ms ease-out;
      }
    }

    &::before,
    &::after {
      content: "";
      position: absolute;
      top: 10px;
      right: 5px;
      width: 20px;
      height: 2px;
      background-color: #939393;
      transform: rotate(45deg);
      transition: background-color 300ms ease-in;
    }

    &::after {
      transform: rotate(-45deg);
    }
  }
}
</style>
